com.singularsys.jep.configurableparser.matchers

## Class ListOrBracketGrammarMatcher

- java.lang.Object
- - com.singularsys.jep.configurableparser.matchers.ListOrBracketGrammarMatcher

- All Implemented Interfaces:
    GrammarMatcher, java.io.Serializable

      public class ListOrBracketGrammarMatcher
      extends java.lang.Object
      implements GrammarMatcher

  A GrammarMatcher which matches overloaded lists of items or brackets. If there is more than one element in the list it will be interpreted as a list, otherwise it will be interpreted as a normal bracketed expression.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ListOrBracketGrammarMatcher(Token open, Token close, Token comma)` Create a ListOrBracketGrammarMatcher

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Jep jep)` Delayed initialisation, this methods is called whenever components of the jep instance are changed.
    `Node` | `match(Lookahead2Iterator<Token> it, GrammarParser parser)` Test whether the input matches this pattern.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ListOrBracketGrammarMatcher

          public ListOrBracketGrammarMatcher(Token open,
                                             Token close,
                                             Token comma)

      Create a ListOrBracketGrammarMatcher
      Parameters:
        `open` - token representing an opening bracket
        `close` - token representing a closing bracket
        `comma` - token representing a list item separator

  - ### Method Detail

    - #### init

          public void init(Jep jep)

      Description copied from interface: `GrammarMatcher`
      Delayed initialisation, this methods is called whenever components of the jep instance are changed.
      Specified by:
        `init` in interface `GrammarMatcher`
      Parameters:
        `jep` - the current jep instance.

    - #### match

          public Node match(Lookahead2Iterator<Token> it,
                            GrammarParser parser)
                     throws ParseException

      Description copied from interface: `GrammarMatcher`
      Test whether the input matches this pattern.
      Specified by:
        `match` in interface `GrammarMatcher`
      Parameters:
        `it` - An iterator inspecting the input
        `parser` - the parser to use when evaluating sub expressions
      Returns:
        if matched returns a node representing the content, return null is does not match
      Throws:
        `ParseException` - if there is a syntactical error in the input.

Copyright © 2018 Singular Systems http://www.singularsys.com/jep